local lootings = {}
local paused = false
local whitelist = {
  'Aethril',
  'Aethril Seed',
  'Blood of Sargeras',
  'Dreamleaf',
  'Dreamleaf Seed',
  'Felwort',
  'Felwort Seed',
  'Fjarnskaggl',
  'Fjarnskaggl Seed',
  'Foxflower',
  'Foxflower Seed',
  'Starlight Rose',
  'Starlight Rose Seed',
  'Yseralline Seed'
}

SLASH_OLD_MACDONALD1 = '/omd'
SLASH_OLD_MACDONALD2 = '/oldmacdonald'

SlashCmdList['OLD_MACDONALD'] = function(msg)
  local cmd = msg:match("(%S+)")
  if cmd == 'report' then
    for k, v in pairs(lootings) do
      print('************')
      print('* ' .. k)
      print('************')
      for i, j in pairs(v) do
        print(i .. ': ' .. j)
      end
    end
  elseif cmd == 'pause' then
    paused = true
    print('You have paused Old MacDonald')
  elseif cmd == 'resume' then
    paused = false
    print('You have resumed Old MacDonald')
  elseif cmd == 'reset' then
    lootings = {}
  end
end

local frame = CreateFrame("Frame")

local function contains (table, value)
  for k, v in ipairs(table) do
    if v == value then
      return true
    end
  end
  return false
end

local function onEvent(self, event, msg)

  local player
  local item, qty = msg:match('%[(.+)%]%D*(%d*)')

  if not contains(whitelist, item) or paused == true then
    return
  end

  qty = tonumber(qty) or 1

  if (msg:match('^You')) then
    player = UnitName('player')
  else
    player = msg:match('^([%S]+)')
  end

  lootings[player] = lootings[player] or {}
  lootings[player][item] = lootings[player][item] or 0
  lootings[player][item] = lootings[player][item] + qty

  if item == 'Foxflower' and qty == 1 then
    lootings[player]['Fox Poop'] = lootings[player]['Fox Poop'] or 0
    lootings[player]['Fox Poop'] = lootings[player]['Fox Poop'] + 1
  end
end

frame:RegisterEvent("CHAT_MSG_LOOT")
frame:SetScript("OnEvent", onEvent)
